Attribute VB_Name = "AD1199"
Rem ************************************************
Rem *** Diese Funktionen stellen die             ***
Rem *** Hardwarefunktionen ber den Treiber      ***
Rem *** ERMA_IO_32BIT.DLL zur Verfgung          ***
Rem ************************************************

Rem Hier BasisAdresse eintragen (&H100 = default)
Public Const BasisAdr = &H120

Rem ************************************************
Rem *** Hier Stehen die Abgleichdaten. Ich habe  ***
Rem *** Standardwerte genommen. Um eine hoehere  ***
Rem *** Genauigkeit zu erreichen, sollten zwei   ***
Rem *** Binaerwerte ermittelt werden (s.u.)      ***
Rem *** Fuer 0V und 10V. Die Werte koennen dann  ***
Rem *** wie folgt berechnet werden:              ***
Rem *** Y1 =  0 ( 0V)   X1 = Binaerwert bei  0V  ***
Rem *** Y2 = 10 (10V)   X2 = Binaerwert bei 10V  ***
Rem *** Steigung = (X2 - X1) / (Y2 - Y1)         ***
Rem *** Offset   = Y2 - (Steigung * X2)          ***
Rem ************************************************
Public Const Steigung = 0.002442
Public Const Offset = 0

Rem ************************************************
Rem *** Einbinden der DLL-Funktionen             ***
Rem ************************************************
Private Declare Function ReadBytePort Lib "ERMA_IO_32BIT.DLL" (ByVal PortNr As Integer) As Integer
Private Declare Function WriteBytePort Lib "ERMA_IO_32BIT.DLL" (ByVal PortNr As Integer, ByVal Wert As Integer) As Integer

Rem ************************************************
Rem *** Diese Funktion liest den Spannungswert   ***
Rem *** an Kanal 0 aus                           ***
Rem ************************************************
Dim I As Integer
Dim J As Integer

Function GetChannel0() As Single
  Rem *** Kanalumschaltung auf Kanal 0
  I = WriteBytePort(BasisAdr, &H30)
  Rem *** Warte bis umgeschaltet
  Rem *** Hier entsteht eine Endlosschleife
  Rem *** wenn keine AD1199 an der Adresse &H120 ist !!!
  Do
    I = ReadBytePort(BasisAdr + 1)
  Loop Until (I And &H10) = &H10
  Rem *** Eigentlichen Messablauf starten
  I = WriteBytePort(BasisAdr, &H30)
  Rem *** Warte bis Wandlung fertig
  Rem *** Hier entsteht eine Endlosschleife
  Rem *** wenn keine AD1199 an der Adresse &H120 ist !!!
  Do
    I = ReadBytePort(BasisAdr + 1)
  Loop Until (I And &H10) = &H10
  Rem *** Binaerwert 8Bit-Weise lesen
  I = ReadBytePort(BasisAdr)
  J = ReadBytePort(BasisAdr + 1)
  Rem *** Von den oberen 8 Bit sind nur die unteren
  Rem *** 4 Bit dem Messwert zugehoerig
  J = J And &HF
  Rem Binaerwert zusammensetzen
  I = I + (J * 256)
  Rem ****************************************
  Rem *** In I  steht nun der Binaerwert   ***
  Rem *** Fuer die Berechnung von Steigung ***
  Rem *** und Offset (Softwareabgleich)    ***
  Rem *** muss dieser Wert einmal fuer 0V  ***
  Rem *** und einmal fuer 10V ermittelt    ***
  Rem *** werden. (Berechnung wie weiter   ***
  Rem *** erklaert. Dies kann auch in der  ***
  Rem *** Software realisiert werden, darum***
  Rem *** sind unsere Demos etwas unueber- ***
  Rem *** sichtlich)                       ***
  Rem ****************************************
  GetChannel0 = Steigung * I + Offset
End Function

